// The xMule Project - A Peer-2-Peer File Sharing Program
//
// Copyright (C) 2003-2005 Theodore R. Smith ( hopeseekr@gmail.com / http://www.xmule.ws/ )
// Copyright (C) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of Version 2 of the GNU General Public
// License as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

#ifndef _FRIENDLISTCTRL_H_
#define _FRIENDLISTCTRL_H_

#include "MuleListCtrl.h"              // CMuleListCtrl
#include "wintypes.h"
#include "Friend.h"                    // CFriend

class CFriendListCtrl : public CMuleListCtrl
{
  friend class CFriendList;

public:
    CFriendListCtrl();
    CFriendListCtrl(wxWindow*& parent, int id, const wxPoint& pos, wxSize siz, int flags);
    virtual ~CFriendListCtrl();

    void Init();
    void Localize();

protected:
    DECLARE_EVENT_TABLE()

    void AddFriend(CFriend* toadd);
    void RemoveFriend(CFriend* toremove);
    void RefreshFriend(CFriend* toupdate);

    virtual bool ProcessEvent(wxEvent& evt);
    void OnNMRclick(wxMouseEvent& evt);

private:
    wxImageList imagelist;
};

#endif // _FRIENDLISTCTRL_H_
