// The xMule Project - A Peer-2-Peer File Sharing Program
//
// Copyright (C) 2003-2005 Theodore R. Smith ( hopeseekr@gmail.com / http://www.xmule.ws/ )
// Copyright (C) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of Version 2 of the GNU General Public
// License as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

#ifndef __MULENOTEBOOKH__
#define __MULENOTEBOOKH__

#include <wx/notebook.h>                    // Needed for wxNotebook

class CMuleNotebook : public wxNotebook {
public:
    CMuleNotebook();
    CMuleNotebook(wxWindow* parent, wxWindowID id, const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = 0, const wxString& name = "notebook");
    void OnRightClick(wxMouseEvent& event);
    DECLARE_DYNAMIC_CLASS(CMuleNotebook)

    void SetMouseListener(wxEvtHandler* listener)
    {
        m_listener = listener;
    }

    wxEvtHandler* GetMouseListener() const
    {
        return m_listener;
    }

private:
    DECLARE_EVENT_TABLE()
    wxEvtHandler* m_listener;
    wxWindow* m_parent;
};

#endif
