// The xMule Project - A Peer-2-Peer File Sharing Program
//
// Copyright (C) 2003-2005 Theodore R. Smith ( hopeseekr@gmail.com / http://www.xmule.ws/ )
// Copyright (C) 2002 Merkur ( devs@emule-project.net / http://www.emule-project.net )
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of Version 2 of the GNU General Public
// License as published by the Free Software Foundation.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

#ifndef PREFERDLG_H
#define PREFERDLG_H

#include <wx/dialog.h>                      // Needed for wxDialog

class CPPgGeneral;
class CPPgConnection;
class CPPgServer;
class CPPgDirectories;
class CPPgFiles;
class CPPgStats;
class CPPgNotify;
class CPPgSourcesDropping;
class CPreferences;

class CPreferencesDlg : public wxDialog
{
    DECLARE_DYNAMIC_CLASS(CPreferencesDlg)

public:
    CPreferencesDlg() {}
    CPreferencesDlg(wxWindow* parent,CPreferences* prefs);
    virtual ~CPreferencesDlg();
    void SetPrefs(CPreferences* in_prefs);
    virtual int ShowModal();

protected:
    unsigned short int m_nActiveWnd;
private:
    DECLARE_EVENT_TABLE()

    void OnInit(CPreferences *prefs);
    CPPgDirectories* m_wndDirectories;
    CPPgNotify* m_wndNotify;
    CPPgSourcesDropping* m_wndSourcesDropping;
    CPreferences* app_prefs;

    void OnBtnOk(wxCommandEvent& evt);
    void OnBtnCancel(wxCommandEvent& evt);
    void OnBtnWizard(wxCommandEvent& evt);

    void Localize(void) {}
};


#endif
